Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2920)
@@ -4499,12 +5248,14 @@
        INTEGER(iwp) :: nzubl, nzutl, isurf, ipcgb
        INTEGER(iwp) :: procid
-
-       INTEGER(iwp), DIMENSION(1:4,inorth_b:iwest_b)  ::  ijdb                               !< start and end of the local domain border coordinates (set in code)
-       LOGICAL, DIMENSION(inorth_b:iwest_b)           ::  isborder                           !< is PE on the border of the domain in four corresponding directions
-
-!
-!--    Find nzub, nzut, nzu via wall_flag_0 array (nzb_s_inner will be 
+       REAL(wp)     :: mrl
+
+
+       !INTEGER(iwp), DIMENSION(1:4,inorth_b:iwest_b)  ::  ijdb                               !< start and end of the local domain border coordinates (set in code)
+       !LOGICAL, DIMENSION(inorth_b:iwest_b)           ::  isborder                           !< is PE on the border of the domain in four corresponding directions
+
+!
+!--    Find nzub, nzut, nzu via wall_flag_0 array (nzb_s_inner will be
 !--    removed later). The following contruct finds the lowest / largest index
-!--    for any upward-facing wall (see bit 12). 
+!--    for any upward-facing wall (see bit 12).
        nzubl = MINVAL( get_topography_top_index( 's' ) )
        nzutl = MAXVAL( get_topography_top_index( 's' ) )
@@ -4538,5 +5289,5 @@
                ENDDO
            ENDDO
-           
+
            nzutl = MAX( nzutl, MAXVAL( pct ) )
 !--        code of plant canopy model uses parameter pch_index
@@ -4544,5 +5295,5 @@
 !--        (pch_index, lad_s and other arrays in PCM are defined flat)
            pch_index = MERGE( leaf_area_density_f%nz - 1, MAXVAL( pch ),       &
-                              leaf_area_density_f%from_file ) 
+                              leaf_area_density_f%from_file )
 
            prototype_lad = MAXVAL( lad_s ) * .9_wp  !< better be *1.0 if lad is either 0 or maxval(lad) everywhere
@@ -4552,5 +5303,5 @@
            !CALL message('usm_init_urban_surface', 'PA0520', 0, 0, -1, 6, 0)
        ENDIF
-       
+
        nzutl = MIN( nzutl + nzut_free, nzt )
 
@@ -4566,4 +5317,16 @@
        nzu = nzut - nzub + 1
 !
+!--    check max_raytracing_dist relative to urban surface layer height
+       mrl = 2.0_wp * nzu * dz
+       IF ( max_raytracing_dist <= mrl ) THEN
+          IF ( max_raytracing_dist /= -999.0_wp ) THEN
+!--          max_raytracing_dist too low
+             WRITE(message_string, '(a,f6.1)') 'Max_raytracing_dist too low, ' &
+                   // 'override to value ', mrl
+             CALL message('radiation_interaction_init', 'PA0521', 0, 0, -1, 6, 0)
+          ENDIF
+          max_raytracing_dist = mrl
+       ENDIF
+!
 !--    allocate urban surfaces grid
 !--    calc number of surfaces in local proc
@@ -4579,5 +5342,5 @@
 
 !
-!--    Number of vertical surfaces in both USM and LSM. Note that all vertical surface elements are 
+!--    Number of vertical surfaces in both USM and LSM. Note that all vertical surface elements are
 !--    already counted in surface_mod.
        startwall = nsurfl+1
@@ -4587,76 +5350,4 @@
        endwall = nsurfl
        nwalls  = endwall - startwall + 1
-       
-!--    range of energy balance surfaces  ! will be treated separately by surf_usm_h and surf_usm_v
-!--    Do we really need usm_energy_balance_land??!!
-!--    !!! Attention: if usm_energy_balance_land = false then only vertical surfaces will be considered here
-       nenergy = 0
-       IF ( energy_balance_surf_h )  THEN
-           startenergy = startland
-           nenergy = nenergy + nlands
-       ELSE
-           startenergy = startwall
-       ENDIF
-       IF ( energy_balance_surf_v )  THEN
-           endenergy = endwall
-           nenergy = nenergy + nwalls
-       ELSE
-           endenergy = endland
-       ENDIF
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!--    block of virtual surfaces
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!--    calculate sky surfaces  ! not used so far!
-       startsky = nsurfl+1
-       nsurfl = nsurfl+(nxr-nxl+1)*(nyn-nys+1)
-       endsky = nsurfl
-       nskys = endsky-startsky+1
-       
-!--    border flags
-#if defined( __parallel )
-       isborder = (/ north_border_pe, south_border_pe, right_border_pe, left_border_pe /)
-#else
-       isborder = (/.TRUE.,.TRUE.,.TRUE.,.TRUE./)
-#endif
-!--    fill array of the limits of the local domain borders
-       ijdb = RESHAPE( (/ nxl,nxr,nyn,nyn,nxl,nxr,nys,nys,nxr,nxr,nys,nyn,nxl,nxl,nys,nyn /), (/4, 4/) )
-!--    calulation of the free borders of the domain
-       startborder = nsurfl + 1
-       DO  ids = inorth_b,iwest_b
-          IF ( isborder(ids) )  THEN
-!--          free border of the domain in direction ids
-             DO  i = ijdb(1,ids), ijdb(2,ids)
-                DO  j = ijdb(3,ids), ijdb(4,ids)
-
-                   k_topo  = get_topography_top_index_ji( j, i, 's' )
-                   k_topo2 = get_topography_top_index_ji( j-jdir(ids), i-idir(ids), 's' )
-
-
-                   k = nzut - MAX( k_topo, k_topo2 )
-                   nsurfl = nsurfl + k
-                ENDDO
-             ENDDO
-          ENDIF
-       ENDDO
-       endborder = nsurfl
-       nborder = endborder - startborder + 1
-
-!--    calulation of the atmospheric virtual surfaces
-!--    each atmospheric cell has 6 faces
-       IF ( atm_surfaces ) THEN
-          DO i = nxl, nxr
-             DO j = nys, nyn
-!--              Find topography top index
-                 k_topo = get_topography_top_index_ji( j, i, 's' )
-                 k = nzut - k_topo
-                 nsurfl = nsurfl + 6 * k
-             ENDDO
-          ENDDO
-!--       exclude the local physical surfaces
-          nsurfl = nsurfl - nlands - nwalls
-!--       exclude the local virtual surfaces
-          nsurfl = nsurfl - nskys - nborder
-       ENDIF
 
 !--    fill gridpcbl and pcbl
@@ -4664,4 +5355,5 @@
            ALLOCATE( pcbl(iz:ix, 1:npcbl) )
            ALLOCATE( gridpcbl(nzub:nzut,nys:nyn,nxl:nxr) )
+           pcbl = -1
            gridpcbl(:,:,:) = 0
            ipcgb = 0
@@ -4679,13 +5371,16 @@
                ENDDO
            ENDDO
-
            ALLOCATE( pcbinsw( 1:npcbl ) )
+           ALLOCATE( pcbinswdir( 1:npcbl ) )
+           ALLOCATE( pcbinswdif( 1:npcbl ) )
            ALLOCATE( pcbinlw( 1:npcbl ) )
        ENDIF
 
-!--    fill surfl
-       ALLOCATE(surfl(5,nsurfl))  ! is it mecessary to allocate it with (5,nsurfl)?        
+!--    fill surfl (the ordering of local surfaces given by the following
+!--    cycles must not be altered, certain file input routines may depend
+!--    on it)
+       ALLOCATE(surfl(5,nsurfl))  ! is it mecessary to allocate it with (5,nsurfl)?
        isurf = 0
-       
+
 !--    add horizontal surface elements (land and urban surfaces)
 !--    TODO: add urban overhanging surfaces (idown_u)
@@ -4705,10 +5400,10 @@
                  surfl(:,isurf) = (/iup_l,k,j,i,m/)
               ENDDO
-              
+
            ENDDO
        ENDDO
 
 !--    add vertical surface elements (land and urban surfaces)
-!--    TODO: remove the hard coding of l = 0 to l = idirection        
+!--    TODO: remove the hard coding of l = 0 to l = idirection
        DO i = nxl, nxr
            DO j = nys, nyn
@@ -4771,121 +5466,15 @@
        ENDDO
 
-!--    add sky
-       DO i = nxl, nxr
-           DO j = nys, nyn
-               isurf = isurf + 1
-               k = nzut
-               surfl(:,isurf) = (/isky,k,j,i,-1/)
-           ENDDO
-       ENDDO
-       
-!--    calulation of the free borders of the domain
-       DO ids = inorth_b,iwest_b
-           IF ( isborder(ids) )  THEN
-!--            free border of the domain in direction ids
-               DO i = ijdb(1,ids), ijdb(2,ids)
-                   DO j = ijdb(3,ids), ijdb(4,ids)
-                       k_topo  = get_topography_top_index_ji( j, i, 's' )
-                       k_topo2 = get_topography_top_index_ji( j-jdir(ids), i-idir(ids), 's' )
-
-                       DO k = MAX(k_topo,k_topo2)+1, nzut
-                           isurf = isurf + 1
-                           surfl(:,isurf) = (/ids,k,j,i,-1/)
-                       ENDDO
-                   ENDDO
-               ENDDO
-           ENDIF
-       ENDDO
-
-!--    adding the atmospheric virtual surfaces 
-       IF ( atm_surfaces ) THEN
-!-- TODO: use flags to identfy atmospheric cells and its coresponding surfaces           
-!--    add horizontal surface
-          DO i = nxl, nxr
-             DO j = nys, nyn
-                k_topo = get_topography_top_index_ji( j, i, 's' )
-
-!--             add upward surface
-                DO k = (k_topo+1), nzut-1
-                   isurf = isurf + 1
-                   surfl(:,isurf) = (/iup_a,k+1,j,i,-1/)
-                ENDDO
-
-!--             add downward surface
-                DO k = (k_topo+1), nzut-1
-                   isurf = isurf + 1
-                   surfl(:,isurf) = (/idown_a,k,j,i,-1/)
-                ENDDO
-             ENDDO
-          ENDDO
-
-!--       add vertical surfaces
-          DO i = nxl, nxr
-             DO j = nys, nyn
-                k_topo = get_topography_top_index_ji( j, i, 's' )
-!--             north
-                IF ( j /= ny ) THEN
-                   ids = inorth_a
-                   jr = min(max(j-jdir(ids),0),ny)
-                   ir = min(max(i-idir(ids),0),nx)
-                   k_topo2 = get_topography_top_index_ji( jr, ir, 's' )
-                   DO k = MAX(k_topo,k_topo2)+1, nzut
-                      isurf = isurf + 1
-                      surfl(:,isurf) = (/inorth_a,k,j,i,-1/)
-                   ENDDO
-                END IF
-!--             south
-                IF ( j /= 0 ) THEN
-                   ids = isouth_a
-                   jr = min(max(j-jdir(ids),0),ny)
-                   ir = min(max(i-idir(ids),0),nx)
-                   k_topo2 = get_topography_top_index_ji( jr, ir, 's' )
-
-                   DO k = MAX(k_topo,k_topo2)+1, nzut
-                      isurf = isurf + 1
-                      surfl(:,isurf) = (/isouth_a,k,j,i,-1/)
-                   ENDDO
-                END IF
-!--             east
-                IF ( i /= nx ) THEN
-                   ids = ieast_a
-                   jr = min(max(j-jdir(ids),0),ny)
-                   ir = min(max(i-idir(ids),0),nx)
-                   k_topo2 = get_topography_top_index_ji( jr, ir, 's' )
-
-                   DO k = MAX(k_topo,k_topo2)+1, nzut
-                      isurf = isurf + 1
-                      surfl(:,isurf) = (/ieast_a,k,j,i,-1/)
-                   ENDDO
-                END IF
-!--             west
-                IF ( i /= 0 ) THEN
-                   ids = iwest_a
-                   jr = min(max(j-jdir(ids),0),ny)
-                   ir = min(max(i-idir(ids),0),nx)
-                   k_topo2 = get_topography_top_index_ji( jr, ir, 's' )
-
-                   DO k = MAX(k_topo,k_topo2)+1, nzut
-                      isurf = isurf + 1
-                      surfl(:,isurf) = (/iwest_a,k,j,i,-1/)
-                   ENDDO
-                END IF
-             ENDDO
-          ENDDO
-
-       ENDIF
-
-!
-!--     broadband albedo of the land, roof and wall surface
-!--     for domain border and sky set artifically to 1.0
-!--     what allows us to calculate heat flux leaving over
-!--     side and top borders of the domain
-        ALLOCATE ( albedo_surf(nsurfl) )
-        albedo_surf = 1.0_wp
-!
-!--     Also allocate further array for emissivity with identical order of 
-!--     surface elements as radiation arrays. 
-!--     MS: Why startenergy:endenergy and albedo surf from 1:nsurfl ?  
-        ALLOCATE ( emiss_surf(startenergy:endenergy)  )
+!
+!--    broadband albedo of the land, roof and wall surface
+!--    for domain border and sky set artifically to 1.0
+!--    what allows us to calculate heat flux leaving over
+!--    side and top borders of the domain
+       ALLOCATE ( albedo_surf(nsurfl) )
+       albedo_surf = 1.0_wp
+!
+!--    Also allocate further array for emissivity with identical order of
+!--    surface elements as radiation arrays.
+       ALLOCATE ( emiss_surf(nsurfl)  )
 
 
@@ -4893,5 +5482,5 @@
 !--    global array surf of indices of surfaces and displacement index array surfstart
        ALLOCATE(nsurfs(0:numprocs-1))
-        
+
 #if defined( __parallel )
        CALL MPI_Allgather(nsurfl,1,MPI_INTEGER,nsurfs,1,MPI_INTEGER,comm2d,ierr)
@@ -4908,7 +5497,8 @@
        nsurf = k
        ALLOCATE(surf(5,nsurf))
-       
+
 #if defined( __parallel )
-       CALL MPI_AllGatherv(surfl, nsurfl*5, MPI_INTEGER, surf, nsurfs*5, surfstart*5, MPI_INTEGER, comm2d, ierr)
+       CALL MPI_AllGatherv(surfl, nsurfl*5, MPI_INTEGER, surf, nsurfs*5, &
+           surfstart(0:numprocs-1)*5, MPI_INTEGER, comm2d, ierr)
 #else
        surf = surfl
@@ -4920,5 +5510,5 @@
 !--    rad_sw_in, rad_lw_in are computed in radiation model,
 !--    splitting of direct and diffusion part is done
-!--    in usm_calc_diffusion_radiation for now
+!--    in calc_diffusion_radiation for now
 
        ALLOCATE( rad_sw_in_dir(nysg:nyng,nxlg:nxrg) )
@@ -4927,6 +5517,6 @@
        rad_sw_in_dir  = 0.0_wp
        rad_sw_in_diff = 0.0_wp
-       rad_lw_in_diff = 0.0_wp 
-       
+       rad_lw_in_diff = 0.0_wp
+
 !--    allocate radiation arrays
        ALLOCATE( surfins(nsurfl) )
